import { __awaiter, __generator } from 'tslib';
import { Component, Input, EventEmitter, Output, NgModule } from '@angular/core';
import { ModalController, IonicModule } from '@ionic/angular';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/modal/modal.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ModalComponent = /** @class */ (function () {
    function ModalComponent(modalController) {
        this.modalController = modalController;
    }
    /**
     * @return {?}
     */
    ModalComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.loadedItems = this.items;
    };
    /**
     * @return {?}
     */
    ModalComponent.prototype.initializeItems = /**
     * @return {?}
     */
    function () {
        this.items = this.loadedItems;
    };
    /**
     * @param {?} evt
     * @return {?}
     */
    ModalComponent.prototype.filterList = /**
     * @param {?} evt
     * @return {?}
     */
    function (evt) {
        this.initializeItems();
        /** @type {?} */
        var searchTerm = evt.srcElement.value;
        if (!searchTerm) {
            return;
        }
        this.items = this.items.filter((/**
         * @param {?} item
         * @return {?}
         */
        function (item) {
            if (item.title && searchTerm) {
                if (item.title.toLowerCase().indexOf(searchTerm.toLowerCase()) > -1) {
                    return true;
                }
                if (item.value.toLowerCase().indexOf(searchTerm.toLowerCase()) > -1) {
                    return true;
                }
                return false;
            }
        }));
    };
    ModalComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ion-modal-custom',
                    template: "<ion-header>\r\n  <ion-toolbar color=\"primary\">\r\n    <ion-buttons slot=\"end\">\r\n      <ion-button (click)=\"modalController.dismiss()\">\r\n        <ion-icon name=\"close-outline\" slot=\"icon-only\"></ion-icon>\r\n      </ion-button>\r\n    </ion-buttons>\r\n    <ion-title>\r\n      {{modalTitle}}\r\n    </ion-title>\r\n  </ion-toolbar>\r\n</ion-header>\r\n\r\n<ion-content>\r\n  <ion-searchbar (ionInput)=\"filterList($event)\" [placeholder]=\"placeHolderSearchText\"></ion-searchbar>\r\n\r\n  <ion-list lines=\"full\">\r\n    <ion-item *ngFor=\"let i of items\" (click)=\"modalController.dismiss(i)\" button>\r\n      <ion-label>\r\n        <h2 class=\"ion-text-wrap\"><strong>{{i.title}}</strong></h2>\r\n        <p>{{i.value}}</p>\r\n      </ion-label>\r\n    </ion-item>\r\n  </ion-list>\r\n</ion-content>\r\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    ModalComponent.ctorParameters = function () { return [
        { type: ModalController }
    ]; };
    ModalComponent.propDecorators = {
        items: [{ type: Input }],
        modalTitle: [{ type: Input }],
        placeHolderSearchText: [{ type: Input }]
    };
    return ModalComponent;
}());
if (false) {
    /** @type {?} */
    ModalComponent.prototype.items;
    /** @type {?} */
    ModalComponent.prototype.modalTitle;
    /** @type {?} */
    ModalComponent.prototype.placeHolderSearchText;
    /** @type {?} */
    ModalComponent.prototype.loadedItems;
    /** @type {?} */
    ModalComponent.prototype.modalController;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ion-select-search.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var IonSelectSearchComponent = /** @class */ (function () {
    function IonSelectSearchComponent(modalController) {
        this.modalController = modalController;
        this.itemSelected = new EventEmitter();
    }
    /**
     * @return {?}
     */
    IonSelectSearchComponent.prototype.showList = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var modal, data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.modalController.create({
                            component: ModalComponent,
                            componentProps: {
                                items: this.items,
                                modalTitle: this.modalTitle,
                                placeHolderSearchText: this.placeHolderSearchText
                            }
                        })];
                    case 1:
                        modal = _a.sent();
                        return [4 /*yield*/, modal.present()];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, modal.onWillDismiss()];
                    case 3:
                        data = (_a.sent()).data;
                        if (data) {
                            this.item = data;
                            this.itemSelected.emit(data);
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    IonSelectSearchComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ion-select-search',
                    template: "<ion-item button detail lines=\"none\" (click)=\"showList()\" [class]=\"clazz\">\r\n  <ion-label position=\"stacked\">\r\n    <h2 class=\"ion-text-wrap\">{{label}}</h2>\r\n    <p class=\"ion-text-wrap\">{{item ? item.title : ''}}</p>\r\n  </ion-label>\r\n</ion-item>\r\n"
                }] }
    ];
    /** @nocollapse */
    IonSelectSearchComponent.ctorParameters = function () { return [
        { type: ModalController }
    ]; };
    IonSelectSearchComponent.propDecorators = {
        items: [{ type: Input }],
        modalTitle: [{ type: Input }],
        placeHolderSearchText: [{ type: Input }],
        label: [{ type: Input }],
        clazz: [{ type: Input }],
        itemSelected: [{ type: Output }]
    };
    return IonSelectSearchComponent;
}());
if (false) {
    /** @type {?} */
    IonSelectSearchComponent.prototype.items;
    /** @type {?} */
    IonSelectSearchComponent.prototype.modalTitle;
    /** @type {?} */
    IonSelectSearchComponent.prototype.placeHolderSearchText;
    /** @type {?} */
    IonSelectSearchComponent.prototype.label;
    /** @type {?} */
    IonSelectSearchComponent.prototype.clazz;
    /** @type {?} */
    IonSelectSearchComponent.prototype.itemSelected;
    /** @type {?} */
    IonSelectSearchComponent.prototype.item;
    /** @type {?} */
    IonSelectSearchComponent.prototype.modalController;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ion-select-search.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var IonSelectSearchModule = /** @class */ (function () {
    function IonSelectSearchModule() {
    }
    IonSelectSearchModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [IonSelectSearchComponent, ModalComponent],
                    imports: [
                        IonicModule,
                        CommonModule
                    ],
                    entryComponents: [ModalComponent],
                    exports: [IonSelectSearchComponent]
                },] }
    ];
    return IonSelectSearchModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ion-select-search.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { IonSelectSearchComponent, IonSelectSearchModule, ModalComponent as ɵa };
//# sourceMappingURL=ion-select-search.js.map
